#include <stdio.h>
#include "symbolc.h"

int main ()
{
  symbolTableEntry *func, *var;
  symbolTableEntry *entry, *entry1, *entry2;

  InitSymbolTable();
  OpenScope("example");

  func = NewFunction("f", VoidRet);
  Insert(func);
  OpenScope("f");

  entry = NewParameter("b", CharType, ByValue, func);
  Insert(entry);

  CloseScope();

  func = NewFunction("ditto", VoidRet);
  Insert(func);
  OpenScope("ditto");

  entry = NewParameter("num", IntegerType, ByValue, func);
  Insert(entry);

  entry = NewParameter("b", CharType, ByValue, func);
  Insert(entry);

  entry = NewParameter("max", IntegerType, ByValue, func);
  Insert(entry);

  CloseScope();

  entry = NewVariable("x", IntegerType);
  Insert(entry);

  entry = NewVariable("s", CharType);
  Insert(entry);

  var = Lookup("x", SEARCH_ALL_SCOPES);
  if (WhatIs(var) != VariableEnt)
    printf("Not an l-value\n");

  entry = NewIntConstant(3);
  Insert(entry);

  entry = NewIntConstant(5);
  Insert(entry);

  entry = NewTemporary(IntegerType);
  Insert(entry);

  if (GetType(var) != IntegerType)
    printf("Not of integer type\n");

  func = Lookup("ditto", SEARCH_ALL_SCOPES);
  if (WhatIs(func) != FunctionEnt || GetReturnType(func) != VoidRet)
    printf("Not a procedure\n");

  entry1 = Lookup("x", SEARCH_ALL_SCOPES);
  entry2 = GetArgument(func, 1);
  if (GetType(entry1) != GetType(entry2))
    printf("Not of the same type\n");

  entry1 = Lookup("s", SEARCH_ALL_SCOPES);
  entry2 = GetArgument(func, 2);
  if (GetType(entry1) != GetType(entry2))
    printf("Not of the same type\n");

  entry1 = NewIntConstant(20);
  Insert(entry1);

  entry2 = GetArgument(func, 3);
  if (GetType(entry1) != GetType(entry2))
    printf("Not of the same type\n");

  func = Lookup("f", SEARCH_ALL_SCOPES);
  if (WhatIs(func) != FunctionEnt || GetReturnType(func) != VoidRet)
    printf("Not a procedure\n");
  
  entry1 = Lookup("s", SEARCH_ALL_SCOPES);
  entry2 = GetArgument(func, 1);
  if (GetType(entry1) != GetType(entry2))
    printf("Not of the same type\n");

  CloseScope();

  return 0;
}
